// Model File Volumen- und Kapazittsallokation

// Legende

//*		Elimination des Modellanteils, da nicht relevant fr Anwendungszusammenhang 
//** 	Modifikation des Modellanteils, da unterschiedlich abgebildet im Anwendungszusammenhang
//***	Hinzugefgter Modellanteil, der in allgemeinem Modell nicht vorhanden war, jedoch zur Abbildung des Anwendungszusammenhangs notwendig ist. 

// Tupeldefinitionen 

/// Erzeugnisstruktur
tuple EnderzeugnisseKomponenten{
string ErzeugnisseEnderzeugnisse;
string ErzeugnisseKomponenten;
}

/// Ressourcen der Produktion

//// Porduktionssysteme - Standorte

tuple ProduktionssystemStandort{
string Produktionssysteme;
string Standorte; 
};
tuple ProduktionssystemStandortLand{
string Produktionssysteme;
string Standorte; 
string Laender;
};

tuple ProduktionssystemStandortLandMarkt{
string Produktionssysteme;
string Standorte; 
string Laender;
string Maerkte;
};

//// Standorte

tuple BetriebStandort{
string Standorte;
int Periode;
};

//// Produktionssysteme

tuple Anlagenlaufzeit{
string Produktionssysteme; 
float Planbelegungszeit;
string Standort;
float Produktionstage; 
int Periode;
}
tuple ProduktionssystemKonfiguration{
string Produktionssysteme;
string Konfiguration;
};
tuple KonfigurationErzeugnisse{
string Konfiguration;
string Erzeugnisse;
}
tuple ProduktionssystemErzeugnisse {
string Produktionssysteme;
string Erzeugnisse;
}
tuple Befaehigungssequenz{
string Produktionssysteme; 
string Vorkonfiguration;
string Konfiguration;
};
//* Eine Disqualifikation tritt im Betrachtungszeitraum nicht auf, weshalb das Tuple eliminiert wird. 
	// tuple Disqualifikationssequenz{
	// string Produktionssysteme; 
	// string Vorkonfiguration;
	// string Konfiguration;
	// };
tuple ProduktionssystemKapazitaetsstufe{
string Produktionssysteme;
float Kapazitaetsstufe;
};
tuple ProduktionssystemKapazitaetsstufeErzeugnisse{
string Produktionssysteme; 
float Kapazitaetsstufe;
string Erzeugnisse;
}
tuple Erweiterungssequenz{
string Produktionssysteme; 
float VorKapazitaetsstufe;
float Kapazitaetsstufe;
}; 
tuple Rueckbausequenz{
string Produktionssysteme; 
float Vorkapazitaetsstufe;
float Kapazitaetsstufe;
};
//* Eine Verlagerung tritt im Betrachtungszeitraum nicht auf, weshalb das Tuple eliminiert wird. 
	// tuple Verlagerungssequenz{
	// string Produktionssysteme;
	// string VonStandort;
	// string NachStandort; 
	// }
tuple ProduktionssystemKapazitaetsstufeKonfiguration{
string Produktionssysteme;
float Kapazitaetsstufe;
string Konfiguration;
string Erzeugnisse;
}

/// Prozesse der Produktion
//// Transportbeziehungen

//** Bei der Bewertung der Logistikkosten wird bereits eine feste Verteilung der Transportmodi je Transportbeziehung 
//** festgelegt (z.B. 85% See, 15% Luft). Obwohl der Transportmodus einen mageblichen Einfluss auf die Transport- und 
//** Lagerhaltungskosten hat, ist die Verteilung der Transportmodi eine externe Entscheidung der Logistik, die
//** die als gegebener Eingangsparameter fr diese Optimierung verwendet werden muss. Sollte sich die Verteilungsannahme
//** ndern, muss dies in den gewichteten Logistikkostenstzen je Transportbeziehung wiedergespiegelt werden. 

tuple Zwischenlieferung{
string ProduktionssystemeProduktionssystemBelieferung;
string PPBStandort;
string ProduktionssystemeProduktionssystemLieferung;
string PPLStandort;
string Erzeugnisse;
}

	// tuple Zwischenlieferung{
	// string ProduktionssystemeProduktionssystemBelieferung;
	// string PPBStandort;
	// string ProduktionssystemeProduktionssystemLieferung;
	// string PPLStandort;
	// string Erzeugnisse;
	// string Transportmodus;
	// }

//** Bei der Bewertung der Logistikkosten wird bereits eine feste Verteilung der Transportmodi je Transportbeziehung 
//** festgelegt (z.B. 85% See, 15% Luft). Obwohl der Transportmodus einen mageblichen Einfluss auf die Transport- und 
//** Lagerhaltungskosten hat, ist die Verteilung der Transportmodi eine externe Entscheidung der Logistik, die
//** die als gegebener Eingangsparameter fr diese Optimierung verwendet werden muss. Sollte sich die Verteilungsannahme
//** ndern, muss dies in den gewichteten Logistikkostenstzen je Transportbeziehung wiedergespiegelt werden. 

tuple Kundenbelieferung{
string ProduktionssystemeKundeBelieferung;
string PKBStandort;
string Kunde; 
string ErzeugnisseEnderzeugnis;
}

	// tuple Kundenbelieferung{
	// string ProduktionssystemeKundeBelieferung;
	// string PKBStandort;
	// string Kunde; 
	// string ErzeugnisseEnderzeugnis;
	// string Transportmodus;
	// }

//* Sprungfixe Kosten werden nicht bercksichtigt. Produktionskosten beziehen sich alleinig auf Cash Flow relevanten, 
//* variablen Anteil der Produktherstellkosten (VA Variabel, MAT, CKD Variabel)
	// tuple StandortProduktionssystemSprungintervalle{
	// string Produktionssysteme; 
	// string Standorte;
	// int Sprungintervalle;
	// }
	
	// tuple ProduktionssystemSprungintervalle{
	// string Produktionssysteme; 
	// int Sprungintervalle;
	// }

//** Bei der Bewertung der Logistikkosten wird bereits eine feste Verteilung der Transportmodi je Transportbeziehung 
//** festgelegt (z.B. 85% See, 15% Luft). Obwohl der Transportmodus einen mageblichen Einfluss auf die Transport- und 
//** Lagerhaltungskosten hat, ist die Verteilung der Transportmodi eine externe Entscheidung der Logistik, die
//** die als gegebener Eingangsparameter fr diese Optimierung verwendet werden muss. Sollte sich die Verteilungsannahme
//** ndern, muss dies in den gewichteten Logistikkostenstzen je Transportbeziehung wiedergespiegelt werden. 
//** Eine Transportbeziehung wird also durch ihre Quelle und Senke charakterisiert und nicht noch zustzlich durch den 
//** Transportmodus der Transportbeziehung. 

tuple StandortStandort{
string VonStandorte;
string NachStandorte;
}

	// tuple StandortStandortTransportmodus{
	// string VonStandorte;
	// string NachStandorte;
	// string Transportmodi;
	// }


//** Bei der Bewertung der Logistikkosten wird bereits eine feste Verteilung der Transportmodi je Transportbeziehung 
//** festgelegt (z.B. 85% See, 15% Luft). Obwohl der Transportmodus einen mageblichen Einfluss auf die Transport- und 
//** Lagerhaltungskosten hat, ist die Verteilung der Transportmodi eine externe Entscheidung der Logistik, die
//** die als gegebener Eingangsparameter fr diese Optimierung verwendet werden muss. Sollte sich die Verteilungsannahme
//** ndern, muss dies in den gewichteten Logistikkostenstzen je Transportbeziehung wiedergespiegelt werden. 
//** Eine Transportbeziehung wird also durch ihre Quelle und Senke charakterisiert und nicht noch zustzlich durch den 
//** Transportmodus der Transportbeziehung. 

tuple StandortKunde{
string VonStandorte;
string Kunden;
}


	// tuple StandortKundeTransportmodus{
	// string VonStandorte;
	// string Kunden;
	// string Transportmodi;
	// }
	
//* Zollbeziehungen werden ber Transportbeziehungen abgebildet.
	// tuple ZollregionZollregionErzeugnisse{
	// string Erzeugnisse;
	// string VonZollregionen;
	// string ZuZollregionen;
	// }

	// tuple ProduktionssystemStandortZollregion{
	// string Produktionssysteme;
	// string Standorte;
	// string Zollregionen;
	// }

/// Markt

tuple KundeLand{
string Kunden;
string Laender;
}

tuple KundeLandMarkt{
string Kunden;
string Laender;
string Maerkte;
}
	// tuple KundeZollregion{
	// string Kunden;
	// string Zollregionen;
	// }





// Indexmengen

/// Eindimensionale Indexmengen

// Perioden 
int MinPeriode= ...;
int MaxPeriode = ...;
range Betrachtungszeitraum0 = MinPeriode-1..MaxPeriode;
range Betrachtungszeitraum = MinPeriode..MaxPeriode;
//* Genereiken und erweiterte Betrachtungszeitrume werden fr die modellgesttzte Kapazittallokation
//* und die Abilund der damit verbunden Kapazittsverluste verwendet. Da die Kapazittsallokation als
//* Eingangsparameter verwendet wird fr die Optimierung, verlieren Generiken und erweiterte Betrachtungszeitrume
//* ihre Bedeutung
// int MinPeriodeGenerik= ...;
// int MaxPeriodeGenerik= ...;
// int MaxPeriodeErweitert= ...;
//range BetrachtungszeitraumErweitert = MinPeriode..MaxPeriodeErweitert;
// range BetrachtungszeitraumGeneriken = MinPeriodeGenerik..MaxPeriodeGenerik; 

// Erzeugnisstruktur
{string}ErzeugnisseEnderzeugnisse= ...;
{string}ErzeugnisseErstKomponenten= ...;
{string}ErzeugnisseSubkomponenten=...;
{string}ErzeugnisseKomponenten= ErzeugnisseErstKomponenten union ErzeugnisseSubkomponenten;
{string}Erzeugnisse = ErzeugnisseEnderzeugnisse union ErzeugnisseKomponenten;

// Mehrdimensionale Indexmengen


/// Erzeugnisstruktur
{EnderzeugnisseKomponenten}BOP=...;
{KonfigurationErzeugnisse}ConP = ...;

/// Ressourcen der Produktion

//// Porduktionssysteme - Standorte
{ProduktionssystemStandort} PNSV =...;
{ProduktionssystemStandort} PNSN = ...;
{ProduktionssystemStandort} PNS = PNSV union PNSN;
{ProduktionssystemStandortLand} PNSL =...;
{ProduktionssystemStandortLandMarkt} PNSLM = ...;

//// Standorte
{BetriebStandort} ST = ...;
{string}StandortePotentiell = {Standort | <Produktionssystem,Standort> in PNSV};
{string}StandorteBestehend = {Standort | <Produktionssystem,Standort> in PNSN};
{string}Standorte = StandortePotentiell union StandorteBestehend; 

//// Porduktionssysteme 
{string}ProduktionssystemePotentiell = {Produktionssystem | <Produktionssystem,Standort> in PNSV};
{string}ProduktionssystemeBestehend = {Produktionssystem | <Produktionssystem,Standort> in PNSN};
{string}Produktionssysteme = ProduktionssystemePotentiell union ProduktionssystemeBestehend;
{Anlagenlaufzeit}EFSGT = ...;
{ProduktionssystemKonfiguration} ECV = ...; 
{ProduktionssystemKonfiguration} ECN = ...;
{ProduktionssystemKonfiguration} EC = ECV union ECN;
{string}Konfigurationen = {Konfiguration | <Produktionssystem,Konfiguration> in EC};
{Befaehigungssequenz}ECIN = ...;
//* Eine Disqualifikation tritt im Betrachtungszeitraum nicht auf, weshalb die Indexmenge eliminiert wird. 
	// {Disqualifikationssequenz}ECDE = {<e,c1,c2> | <e,c1> in EC, <e,c2> in EC};
{ProduktionssystemErzeugnisse}EP = {<e,p> | <e,c> in EC, <c,p> in ConP};
{ProduktionssystemKapazitaetsstufe}EK = ...;
{float}Kapazitaetsstufen = {Kapazitaetsstufe | <Produktionssystem,Kapazitaetsstufe> in EK};
{Erweiterungssequenz}EKIN = ...;
{Rueckbausequenz}EKDE = ...;
{ProduktionssystemKapazitaetsstufeErzeugnisse}EKP = ...;
//* Eine Verlagerung tritt im Betrachtungszeitraum nicht auf, weshalb die Indexmenge eliminiert wird. 
	// {Verlagerungssequenz}VES = ...;
//* Separierte Betrachtung von Produktionssystem-Konfiguration und Konfiguration-Erzeugnise macht diese Indexmenge berflssig
	// {ProduktionssystemKapazitaetsstufeKonfiguration}EKCP = {<e,k,c,p> | <e,k> in EK, <e,c> in EC, <c,p> in ConP};

/// Prozesse der Produktion

//// Transportbeziehungen

{Zwischenlieferung}ROUf=...;
{string} ORIf = {ProduktionssystemeProduktionssystemBelieferung | <ProduktionssystemeProduktionssystemBelieferung,PPBStandort,ProduktionssystemeProduktionssystemLieferung,PPLStandort,Produkte> in ROUf};
{string} DESf = {ProduktionssystemeProduktionssystemLieferung | <ProduktionssystemeProduktionssystemBelieferung,PPBStandort,ProduktionssystemeProduktionssystemLieferung,PPLStandort,Produkte> in ROUf};  
{Kundenbelieferung}ROUh=...;
{string} ORIh = {ProduktionssystemeKundeBelieferung | <ProduktionssystemeKundeBelieferung,PKBStandort,Kunde,Produkte> in ROUh};
{string} ORI = ORIf union ORIh; 
	//* Zollkosten werden ber individuelle Transportbeziehungen bercksichtigt. 
	// {ZollregionZollregionErzeugnisse}ROUz=...;
	// {KundeZollregion}HZ=...;
	//* Zollbeziehungen werden ber individuelle Transportbeziehungen bercksichtigt. 
	// {ProduktionssystemStandortZollregion}PNSVZ=...;
	// {ProduktionssystemStandortZollregion}PNSNZ=...;
	// {ProduktionssystemStandortZollregion}PNSZ= PNSVZ union PNSNZ;

/// Kosten der Produktion

	//* Sprungfixe Kosten werden nicht bercksichtigt. Produktionskosten beziehen sich alleinig auf Cash Flow relevanten, 
	//* variablen Anteil der Produktherstellkosten (VA Variabel, MAT, CKD Variabel)
	//{StandortProduktionssystemSprungintervalle}SEI=...;
	// {ProduktionssystemSprungintervalle}EI= {<Produktionssystem,Sprungintervall> | <Standort,Produktionssystem,Sprungintervall> in SEI};
	// {int}Sprungintervalle = {Sprungintervall | <Produktionssystem,Sprungintervall> in EI};

/// Markt

{string}Kunden = {Kunde | <ProduktionssystemeKundeBelieferung,PKBStandort,Kunde,Produkte> in ROUh};
{string}Maerkte =...;
{string}Laender=...;
{KundeLand}HL=...;
{KundeLandMarkt}HLM=...;
	//* Beziehungen zwischen einer Transportquelle und Transportsenke sind notwendig um Distanzen zu ermitteln. Da der Transportkostensatz nicht
	//* nicht auf Basis der Distanz sondern auf Basis einer konkreten Transportbeziehung ermittelt wird, mssen diese Beziehungen nicht
	//* bercksichtigt werden. 
	// {StandortStandort}SS={<PPBStandort,PPLStandort>|<ProduktionssystemeProduktionssystemBelieferung,PPBStandort,ProduktionssystemeProduktionssystemLieferung,PPLStandort,Produkte> in ROUf};
	// {StandortKunde}SH={<PKBStandort,Kunde>|<ProduktionssystemeKundeBelieferung,PKBStandort,Kunde,Produkte> in ROUh};






// Parameter

/// Erzeugnisstruktur

int mbkp[BOP]=...;
//* Lagerhaltungskosten werden ignoriert. Es werden Kapitalbindungskosten durch den Transport whrend der Transport- und Lagerzeit bercksichtigt.
	// int maxinv[EP][Betrachtungszeitraum]=...;
	// int invMinPeriode[EP]=...;

/// Ressourcen der Produktion

//// Standorte
int eit[ST] = ...;
//// Produktionssysteme
int eSOP[ProduktionssystemePotentiell]=...;
int enEOP[ProduktionssystemePotentiell]=...;
int evEOP[ProduktionssystemeBestehend]=...;
float oee[Produktionssysteme][Betrachtungszeitraum]=...;
float spd=...;
float capAZH[Produktionssysteme][Betrachtungszeitraum]=...;
float maxuek[Produktionssysteme][Betrachtungszeitraum]=...;
float mincap[Produktionssysteme][Betrachtungszeitraum]=...;
//* Kapazittsverluste werden ber OEE und CT abgebildet und nicht als an Planungsperioden anteilige Kapazittsverluste
	// float tsh[Produktionssysteme][Betrachtungszeitraum]=...; 
float ct[EP][Betrachtungszeitraum]=...;
int config[ConP]=...;
int cytVSOP[ECV]=...;
int cytNSOP[ECN]=...;
//* Kapazittsverluste werden ber OEE und CT abgebildet und nicht als an Planungsperioden anteilige Kapazittsverluste
	// int  zvec[EC]=...;
	// int zvek[EK]=...;
	// int zves[PNS]=...;
	// float lossec[EC][BetrachtungszeitraumGeneriken]=...;
	// float lossek[EK][BetrachtungszeitraumGeneriken]=...;
	// float losses[PNS][BetrachtungszeitraumGeneriken]=...;

/// Kosten der Produktion

//// Einmalaufwand
float cEVTe[ProduktionssystemePotentiell]=...;
float cEVTec[ECIN]=...;
float cEVTek[EKIN]=...;
//* Eine Verlagerung tritt im Betrachtungszeitraum nicht auf, weshalb der Kostenfaktor eliminiert wird. 
	// float cEVTes[VES]=...;
float cDEMe[ProduktionssystemePotentiell]=...;
//* Eine Disqualifikation tritt im Betrachtungszeitraum nicht auf, weshalb der Kostenfaktor eliminiert wird. 
	// float cDEMec[ECDE]=...;
float cDEMek[EKDE]=...;

//// Laufende Aufwendungen
//** cVAR abhngig von Produktionsvolumen auf Produktionssystem und nicht von Produktionssystem; keine Aufteilung in VA variabel und MAT
float cVAR[EP][Betrachtungszeitraum]=...;
	// float cVAR[Produktionssysteme][Betrachtungszeitraum]=...;
	// float cMAR[Produktionssysteme][Betrachtungszeitraum]=...;
	// float cPAR[Produktionssysteme][Betrachtungszeitraum]=...;
//* Es werden nur variable Produktionskosten in Form des variablen, Cash Flow-relevanten Anteils der Produktherstellkosten (PPC) bercksichtigt (MAT, VA Variable, CKD Variabel)
	// float cFIXe[Produktionssysteme][Betrachtungszeitraum]=...;
	// float cFIXkyt[EK]=...;
	// float cSFI[SEI]=...;
	// float UG[EI]=...;
	// float OG[EI]=...;
//** Es wird ein Anteil bestimmter Transportmodi an Transporten angenommen und es wird ein durch den Anteil der Transportmodi
//** gewichteter Transportkostensatz je Transportbeziehung errechnet  
float cTVf[ROUf][Betrachtungszeitraum]=...;
float cTVh[ROUh][Betrachtungszeitraum]=...;
float cINVf[ROUf][Betrachtungszeitraum]=...;
float cINVh[ROUh][Betrachtungszeitraum]=...;
float cTARf[ROUf][Betrachtungszeitraum]=...; 
float cTARh[ROUh][Betrachtungszeitraum]=...;
	// float cTV[Erzeugnisse][Transportmodi]=...;
	// float cINV[EP][Betrachtungszeitraum]=...;
	// float cTAR[ROUz][Betrachtungszeitraum]=...; 
//** Distanzen werden nicht bercksichtigt, da ein Transportkostensatz und Zollkostensatz je individuelle Transportbeziehung ermittelt wird.
	// float distSSO[SSO]=...;
	// float distSHO[SHO]=...;
	
//// Budget
//* Wenn es zu einer separaten Kapazittsallokation kommt, die als Engangsparameter fr die modellgesttzte Volumenallokation fungiert und 
//* in der bereits Budgetbeschrnkungen bercksichtigt werden, mssen diese nicht nochmals in der modellgesttzten Volumenallokation
//* abgefragt werden.  
	// float maxcapex[Betrachtungszeitraum]=...; 

//// Kapitalwertbetrachtung
//* Es wird die Gesamtkostenbetrachtung und nicht die Kapitalwertbetrachtung genutzt. 
	// float r=...;
	// float cRET[ErzeugnisseEnderzeugnisse][Kunden][Betrachtungszeitraum]=...;
	// float cRW[ProduktionssystemePotentiell];


/// Markt

int dem[Kunden][ErzeugnisseEnderzeugnisse][Betrachtungszeitraum]=...;
	//* Es wird eine vollkommene Erfllung des Marktbedarfs als Voraussetzung angenommen.
	// float maxfv[ErzeugnisseEnderzeugnisse][Betrachtungszeitraum];

/// Strategie

//* Fokus liegt zunchst auf Belieferung aus der Triade/dem Markt. 
	// float minvalloc[Laender][Betrachtungszeitraum]=...;
float minvalmarket[Maerkte][Betrachtungszeitraum]=...;





// Entscheidungsvariablen

		
/// Binre Entscheidungsvariablen

//// Ressourcen der Produktion

dvar boolean bEIT[Produktionssysteme][Betrachtungszeitraum];
dvar boolean bEIsop[ProduktionssystemePotentiell][Betrachtungszeitraum];
dvar boolean bEIeop[Produktionssysteme][Betrachtungszeitraum];
dvar boolean bCYT[EC][Betrachtungszeitraum];
dvar boolean bCYTIN[ECIN][Betrachtungszeitraum];
//* Eine Disqualifikation tritt im Betrachtungszeitraum nicht auf, weshalb die Binrvariable eliminiert wird. 	
	// dvar boolean bCYTDE[ECDE][Betrachtungszeitraum];
dvar boolean bKYT[EK][Betrachtungszeitraum];
dvar boolean bKYTIN[EKIN][Betrachtungszeitraum];
dvar boolean bKYTDE[EKDE][Betrachtungszeitraum];
//* dvar boolean bEST[PNS][Betrachtungszeitraum];
//* Eine Verlagerung tritt im Betrachtungszeitraum nicht auf, weshalb die Entscheidungsvariable eliminiert wird. 
	// dvar boolean bVYT[VES][Betrachtungszeitraum];
//* Sprungfixe Kosten werden nicht bercksichtigt. Produktionskosten beziehen sich alleinig auf Cash Flow relevanten, 
//* variablen Anteil der Produktherstellkosten (VA Variabel, MAT, CKD Variabel)
	// dvar boolean bEII[EI][Betrachtungszeitraum];


/// Kontinuierliche Entscheidungsvariablen

//// Ressourcen der Produktion

dvar int+ fAZH[Produktionssysteme][Betrachtungszeitraum];
dvar int+ fAZV[Produktionssysteme][Betrachtungszeitraum];
dvar int+ fAUE[Produktionssysteme][Betrachtungszeitraum]; 

//* Kapazittsverluste werden ber OEE und CT abgebildet und nicht als an Planungsperioden anteilige Kapazittsverluste
	// dvar float+ fLOSS[Produktionssysteme][Betrachtungszeitraum];
	// dvar float+ fLOSSec[ECIN][Betrachtungszeitraum];
	// dvar float+ fLOSSek[EKIN][Betrachtungszeitraum];
	// dvar float+ fLOSSes[VES][Betrachtungszeitraum];

//// Prozesse der Produktion

///// Produktion
dvar int+ fPV[EP][Betrachtungszeitraum];
dvar int+ fPVe[Produktionssysteme][Betrachtungszeitraum];
dvar int+ fFVpe[ErzeugnisseEnderzeugnisse][Betrachtungszeitraum];

///// Transport
dvar int+ fTVf[ROUf][Betrachtungszeitraum]; 
dvar int+ fTVh[ROUh][Betrachtungszeitraum]; 
//* Zollkosten werden in Abhngigkeit der Transporbeziehung und den Transportvolumen auf der jeweiligen Transportbeziehung errechnet. 
//* Eine gesonderte Betrachtung der Zollkosten ist deshalb berflssig.
	// dvar float+ fTVz[ROUz][Betrachtungszeitraum]; 
//* Lagerhaltungskosten werden ignoriert. Es werden Kapitalbindungskosten durch den Transport whrend der Transport- und Lagerzeit bercksichtigt.
	// dvar int+ fINV[EP][Betrachtungszeitraum]; 
//* Es werden nur variable Produktionskosten in Form des Cash Flow-relevanten Anteils der variablen 
//* Produktionskosten bercksichtigt (MAT, VA Variable, CKD Variabel)
	// dvar float+ fFIXe[Produktionssysteme][Betrachtungszeitraum]; 






	
/// Entscheidungsausdrcke	

//// (60) Berechnung Einmalaufwand Errichtung
dexpr float EinmalaufwandErrichtung = sum(e in ProduktionssystemePotentiell,t in Betrachtungszeitraum)bEIsop[e][t]*cEVTe[e];
dexpr float EAE[t in Betrachtungszeitraum] = sum(e in ProduktionssystemePotentiell)bEIsop[e][t]*cEVTe[e];
// dexpr float EinmalaufwandErrichtungAb = sum(e in ProduktionssystemePotentiell,t in Betrachtungszeitraum)(bEIsop[e][t]*cEVTe[e]/pow(1+r,t));
//// (62) Berechnung Einmalaufwand Befaehigung
dexpr float EinmalaufwandBefaehigung =  sum(<e,c1,c2> in ECIN,t in Betrachtungszeitraum)bCYTIN[<e,c1,c2>][t]*cEVTec[<e,c1,c2>];
dexpr float EAC[t in Betrachtungszeitraum] = sum(ec1c2 in ECIN)bCYTIN[ec1c2][t]*cEVTec[ec1c2];
// dexpr float EinmalaufwandBefaehigungAb =  sum(<e,c1,c2> in ECIN,t in Betrachtungszeitraum)(bCYTIN[<e,c1,c2>][t]*cEVTec[<e,c1,c2>]/pow(1+r,t));
//// (64) Berechnung Einmalaufwand Erweiterung
dexpr float EinmalaufwandErweiterung = sum(<e,k1,k2> in EKIN,t in Betrachtungszeitraum)bKYTIN[<e,k1,k2>][t]*cEVTek[<e,k1,k2>];
dexpr float EAK[t in Betrachtungszeitraum] = sum(ek1k2 in EKIN)bKYTIN[ek1k2][t]*cEVTek[ek1k2];
// dexpr float EinmalaufwandErweiterungAb = sum(<e,k1,k2> in EKIN,t in Betrachtungszeitraum)(bKYTIN[<e,k1,k2>][t]*cEVTek[<e,k1,k2>]/pow(1+r,t));
//// (66) Berechnung Einmalaufwand Verlagerung
//* Eine Verlagerung tritt im Betrachtungszeitraum nicht auf, weshalb der Einmalaufwand eliminiert wird. 
	// dexpr float EinmalaufwandVerlagerung = sum(<e,s1,s2> in VES,t in Betrachtungszeitraum)bVYT[<e,s1,s2>][t]*cEVTes[<e,s1,s2>];
	// dexpr float EAV[t in Betrachtungszeitraum] = sum(es1s2 in VES)bVYT[es1s2][t]*cEVTes[es1s2];
// dexpr float EinmalaufwandVerlagerungAb = sum(<e,s1,s2> in VES,t in Betrachtungszeitraum)(bVYT[<e,s1,s2>][t]*cEVTes[<e,s1,s2>]/pow(1+r,t));
//// (61) Berechnung Demontagekosten Stilllegung
dexpr float DemontagekostenStilllegung = sum(e in ProduktionssystemePotentiell,t in Betrachtungszeitraum)bEIeop[e][t]*cDEMe[e];
dexpr float DAE[t in Betrachtungszeitraum] = sum(e in ProduktionssystemePotentiell)bEIeop[e][t]*cDEMe[e];
// dexpr float DemontagekostenStilllegungAb = sum(e in ProduktionssystemePotentiell,t in Betrachtungszeitraum)(bEIeop[e][t]*cDEMe[e]/pow(1+r,t));  
//// (63) Berechnung Demontagekosten Disqualifikation
//* Disqualifikation tritt im Betrachtungszeitraum nicht auf, weshalb die Binrvariable eliminiert wird. 
	// dexpr float DemontagekostenDisqualifikation = sum(<e,c1,c2> in ECDE,t in Betrachtungszeitraum)bCYTDE[<e,c1,c2>][t]*cDEMec[<e,c1,c2>];
	// dexpr float DAC[t in Betrachtungszeitraum] = sum(ec1c2 in ECDE)bCYTDE[ec1c2][t]*cDEMec[ec1c2];
	// dexpr float DemontagekostenDisqualifikationAb = sum(<e,c1,c2> in ECDE,t in Betrachtungszeitraum)(bCYTDE[<e,c1,c2>][t]*cDEMec[<e,c1,c2>]/pow(1+r,t));
//// (65) Berechnung Demontagekosten Reduktion
dexpr float DemontagekostenReduktion = sum(<e,k1,k2> in EKDE,t in Betrachtungszeitraum)bKYTDE[<e,k1,k2>][t]*cDEMek[<e,k1,k2>];
dexpr float DAK[t in Betrachtungszeitraum] = sum(ek1k2 in EKDE)bKYTDE[ek1k2][t]*cDEMek[ek1k2];
// dexpr float DemontagekostenReduktionAb = sum(<e,k1,k2> in EKDE,t in Betrachtungszeitraum)(bKYTDE[<e,k1,k2>][t]*cDEMek[<e,k1,k2>]/pow(1+r,t));
//// Berechnung Einmalaufwand 
dexpr float Einmalaufwand = EinmalaufwandErrichtung + EinmalaufwandBefaehigung + EinmalaufwandErweiterung +  DemontagekostenStilllegung +  DemontagekostenReduktion;
// dexpr float Einmalaufwand = EinmalaufwandErrichtung + EinmalaufwandBefaehigung + EinmalaufwandErweiterung + EinmalaufwandVerlagerung +  DemontagekostenStilllegung + DemontagekostenDisqualifikation + DemontagekostenReduktion;
dexpr float EAW[t in Betrachtungszeitraum] = EAE[t] + EAC[t] + EAK[t] + DAE[t] + DAK[t];
// dexpr float EinmalaufwandAb = EinmalaufwandErrichtungAb + EinmalaufwandBefaehigungAb + EinmalaufwandErweiterungAb + EinmalaufwandVerlagerungAb +  DemontagekostenStilllegungAb + DemontagekostenDisqualifikationAb + DemontagekostenReduktionAb;

//** Fixkosten, Sprungfixe Kosten werden nicht bercksichtigt. Produktionskosten beziehen sich alleinig auf Cash Flow relevanten, variablen Anteil der Produktherstellkosten (VA Variabel, MAT, CKD Variabel)
////  (71) Berechnung der Fixkosten
// dexpr float Fixkosten = sum(e in Produktionssysteme, t in Betrachtungszeitraum) (fFIXe[e][t]*cFIXe[e][t]); 
// dexpr float FKE[t in Betrachtungszeitraum] = sum(e in Produktionssysteme) (fFIXe[e][t]*cFIXe[e][t]);
// dexpr float FixkostenAb = sum(e in Produktionssysteme, t in Betrachtungszeitraum) fFIXe[e][t]*cFIXe[e][t]/pow(1+r,t);
//// (73) Berechnung der Sprungfixen Kosten
// dexpr float SprungfixeKosten = sum(<s,e,i> in SEI, t in Betrachtungszeitraum)(bEII[<e,i>][t]*cSFI[<s,e,i>]); 
// dexpr float SPE[t in Betrachtungszeitraum] = sum(<s,e,i> in SEI)(bEII[<e,i>][t]*cSFI[<s,e,i>]);
// dexpr float SprungfixeKostenAb = sum(<s,e,i> in SEI, t in Betrachtungszeitraum)bEII[<e,i>][t]*cSFI[<s,e,i>]/pow(1+r,t);
//// (77) Berechnung der variablen Produktionskosten
dexpr float VariableKosten = sum(ep in EP, t in Betrachtungszeitraum)(cVAR[ep][t] * fPV[ep][t]);
dexpr float VKE[t in Betrachtungszeitraum] = sum(ep in EP)(cVAR[ep][t] * fPV[ep][t]);
// dexpr float VariableKostenAb = sum(e in Produktionssysteme, t in Betrachtungszeitraum)cVAR[e][t] * fAZH[e][t]/pow(1+r,t);
//// (70) Berechnung der Produktionskosten
dexpr float Produktionskosten = VariableKosten;
// dexpr float Produktionskosten = Fixkosten + SprungfixeKosten + VariableKosten;
dexpr float PKE[t in Betrachtungszeitraum] = VKE[t];
// dexpr float PKE[t in Betrachtungszeitraum] = FKE[t] + SPE[t] + VKE[t];
// dexpr float ProduktionskostenAb = FixkostenAb + SprungfixeKostenAb + VariableKostenAb;
//** Berechnung der gesamten Logistikkosten je Transportbeziehung und Transportvolumen auf Transportbeziehung, anstatt
//** separater Berechnung der Lagerhaltungs-, Transport- und Zollkosten
//// (78) Berechnung der Logistikkosten fr Zwischenbelieferungen
dexpr float LogistikkostenZwischenbelieferungen = sum(e1s1e2s2p in ROUf, t in Betrachtungszeitraum) (fTVf[e1s1e2s2p][t]*(cTVf[e1s1e2s2p][t]+cINVf[e1s1e2s2p][t]+cTARf[e1s1e2s2p][t]));
dexpr float LOGf[t in Betrachtungszeitraum] = sum(e1s1e2s2p in ROUf) (fTVf[e1s1e2s2p][t]*(cTVf[e1s1e2s2p][t]+cINVf[e1s1e2s2p][t]+cTARf[e1s1e2s2p][t]));
// dexpr float TransportkostenZwischenbelieferungen = sum(<e1,s1,e2,s2,p,o> in ROUf, t in Betrachtungszeitraum) (fTVf[<e1,s1,e2,s2,p,o>][t]*distSSO[<s1,s2,o>]*cTV[p][o]);
// dexpr float TKF[t in Betrachtungszeitraum] = sum(<e1,s1,e2,s2,p,o> in ROUf) (fTVf[<e1,s1,e2,s2,p,o>][t]*distSSO[<s1,s2,o>]*cTV[p][o]);
// dexpr float TransportkostenZwischenbelieferungenAb = sum(<e1,s1,e2,s2,p,o> in ROUf, t in Betrachtungszeitraum) (fTVf[<e1,s1,e2,s2,p,o>][t]*distSSO[<s1,s2,o>]*cTV[p][o]/pow(1+r,t));
//// (79) Berechnung der Logistikkosten fr Kundenbelieferungen
dexpr float LogistikkostenKundenbelieferungen = sum(e1s1hp in ROUh, t in Betrachtungszeitraum) (fTVh[e1s1hp][t]*(cTVh[e1s1hp][t] + cINVh[e1s1hp][t]+cTARh[e1s1hp][t]));
dexpr float LOGh [t in Betrachtungszeitraum] = sum(e1s1hp in ROUh) (fTVh[e1s1hp][t]*(cTVh[e1s1hp][t] + cINVh[e1s1hp][t]+cTARh[e1s1hp][t]));
//dexpr float TransportkostenKundenbelieferungen = sum(<e1,s1,h,p,o> in ROUh, t in Betrachtungszeitraum) (fTVh[<e1,s1,h,p,o>][t]*distSHO[<s1,h,o>]*cTV[p][o]);
// dexpr float TKM [t in Betrachtungszeitraum] = sum(<e1,s1,h,p,o> in ROUh) (fTVh[<e1,s1,h,p,o>][t]*distSHO[<s1,h,o>]*cTV[p][o]);
// dexpr float TransportkostenKundenbelieferungenAb = sum(<e1,s1,h,p,o> in ROUh, t in Betrachtungszeitraum) (fTVh[<e1,s1,h,p,o>][t]*distSHO[<s1,h,o>]*cTV[p][o]/pow(1+r,t));
//// Summe Logistikkosten
dexpr float Logistikkosten = LogistikkostenZwischenbelieferungen + LogistikkostenKundenbelieferungen;
dexpr float LOG[t in Betrachtungszeitraum] = LOGf[t] + LOGh[t];
// dexpr float TK[t in Betrachtungszeitraum] = TKF[t] + TKM[t];
// dexpr float TransportkostenAb = TransportkostenZwischenbelieferungenAb + TransportkostenKundenbelieferungenAb;
//// (80) Berechnung der Lagerhaltungskosten
// dexpr float Lagerhaltungskosten = sum(ep in EP, t in Betrachtungszeitraum)(fINV[ep][t]*cINV[ep][t]);
// dexpr float LAK[t in Betrachtungszeitraum] = sum(ep in EP)(fINV[ep][t]*cINV[ep][t]);
// dexpr float LagerhaltungskostenAb = sum(ep in EP, t in Betrachtungszeitraum)(fINV[ep][t]*cINV[ep][t]/pow(1+r,t));
//// (81) Berechnung der Zollkosten
// dexpr float Zollkosten = sum(<z1,z2,p> in ROUz, t in Betrachtungszeitraum)(fTVz[<z1,z2,p>][t]*cTAR[<z1,z2,p>][t]);
// dexpr float ZOK[t in Betrachtungszeitraum] = sum(<z1,z2,p> in ROUz, t in Betrachtungszeitraum)(fTVz[<z1,z2,p>][t]*cTAR[<z1,z2,p>][t]);
// dexpr float ZollkostenAb = sum(<z1,z2,p> in ROUz, t in Betrachtungszeitraum)(fTVz[<z1,z2,p>][t]*cTAR[<z1,z2,p>][t]/pow(1+r,t));
//// Summe Logistikkosten
// dexpr float Logistikkosten = Transportkosten + Lagerhaltungskosten + Zollkosten; 
// dexpr float LOG[t in Betrachtungszeitraum] = TKF[t] + TKM [t] + LAK[t] + ZOK[t];
// dexpr float LogistikkostenAb = TransportkostenAb + LagerhaltungskostenAb + ZollkostenAb; 

//// Summe Laufende Aufwendungen
dexpr float LaufendeAufwendungen = Produktionskosten + Logistikkosten; 
dexpr float LAW[t in Betrachtungszeitraum] = PKE[t] + LOG[t];
// dexpr float LaufendeAufwendungenAb = ProduktionskostenAb + LogistikkostenAb; 

// Gesamtkosten
dexpr float Gesamtkosten = Einmalaufwand + LaufendeAufwendungen; 
dexpr float GK[t in Betrachtungszeitraum] = EAW[t] + LAW[t];

//* Umsatz und Restwertberechnungen werden nicht bercksichtigt, da eine Optimierung hinsichlich der entscheidungsrelevanten Gesamtkosten erfolgt. 
// Summe Umsatz
// dexpr float Umsatz = sum(<e,s,h,p,o> in ROUh, t in Betrachtungszeitraum) fTVh[<e,s,h,p,o>][t]*cRET[p][h][t];
// dexpr float UM[t in Betrachtungszeitraum] = sum(<e,s,h,p,o> in ROUh) fTVh[<e,s,h,p,o>][t]*cRET[p][h][t];
// dexpr float UmsatzAb = sum(<e,s,h,p,o> in ROUh, t in Betrachtungszeitraum) (fTVh[<e,s,h,p,o>][t]*cRET[p][h][t]/pow(1+r,t));
// Restwert der errichteten Produktionssysteme innerhalb des Betrachtungszeitraums
// dexpr float Restwert = sum(e in ProduktionssystemePotentiell)bEIT[e][MaxPeriode]*cRW[e];
// dexpr float RestwertAb = sum(e in ProduktionssystemePotentiell)(bEIT[e][MaxPeriode]/pow(1+r,MaxPeriode));
// Kapitalwert
// dexpr float Kapitalwert = Umsatz + Restwert - Einmalaufwand - LaufendeAufwendungen;
// dexpr float KapitalwertAb = UmsatzAb + RestwertAb - EinmalaufwandAb - LaufendeAufwendungenAb;





// Zielfunktion

//* Aufgrund der Komplexitt der Datenerfassung (Varianz der Daten und deren Einfluss auf Allokationsergebnis,  
//* Vielzahl der beteiligten Personen am Entscheidungsprozess, Individualitt der Beurteilung je Maschine)
//* bei der Kapitalwertoptimierung, wird auf die Gesamtkostenoptimierung zurckgegriffen
// maximize KapitalwertAb;
minimize Gesamtkosten;





// Restriktionen

/// Ressourcen der Produktion
//// Betrieb von Produktionssystemen (1) - (8)
//// Konfigurationsplanung fr Produktionssysteme (9) - (15) 
//// Kapazittsplanung fr Produktionssysteme (16) - (20) 
//// Anforderungen aus der Netzwerkmigration (21) - (47)
///Prozesse der Produktion
//// Einhaltung der maximalen Kapazitt (48) - (52) 
//// Sicherstellung der Materialflusserhaltung (53) - (55) 
//// Abbildung der Lagerhaltung (56) - (58)
//// Vermeidung einer Kundenueberbelieferung (59)
///Kosten der Produktion
//// Einmalaufwand (60) - (68)
//// Laufende Aufwendungen (69) - (82)
///Strategie (83) - (85) 


	
//// (9) a) 
constraint ctProduktionsvolumenKonfigurationNExistent[EC][Erzeugnisse][Betrachtungszeitraum];
//// (9) b) 
constraint ctProduktionsvolumenKonfigurationExistent[EC][Erzeugnisse][Betrachtungszeitraum];
//// (10) 
constraint ctBetriebKonfiguration[EC][Betrachtungszeitraum];
//// (12) 
constraint ctBefaehigung[ECIN][Betrachtungszeitraum];
//// (14) 
constraint ctKonfigurationProduktionssystemePotentiell[ProduktionssystemePotentiell];
//// (13)
// constraint ctDisqualifikation[ECDE][Betrachtungszeitraum];
//// (16)
constraint ctKapazitaetsstufe[Produktionssysteme][Betrachtungszeitraum];
//// (17)
constraint ctErweiterung[EKIN][Betrachtungszeitraum];
//// (19)
constraint ctKapazitaetsstufeProduktionssystemePotentiell[ProduktionssystemePotentiell];
//// (18)
constraint ctRueckbau[EKDE][Betrachtungszeitraum];
//// (21)
constraint ctBetriebProduktionsssystemeBestehend[ProduktionssystemeBestehend];
//// (1) a) 
constraint ctProduktionsvolumenBetriebN[Produktionssysteme][Betrachtungszeitraum];
//// (1) b) 
constraint ctProduktionsvolumenBetrieb[Produktionssysteme][Betrachtungszeitraum];
//// (1) c)
constraint ctSummeProduktionsvolumenProduktionssystem[Produktionssysteme][Betrachtungszeitraum];
//// (6) 
constraint ctAusserbetriebnahmeProdEOP[Produktionssysteme][Betrachtungszeitraum];
//// (7)
constraint ctAusserbetriebnahmeEOPProd[Produktionssysteme][Betrachtungszeitraum];
//// (11)
constraint ctKonfiguration[Produktionssysteme][Betrachtungszeitraum];
//// (8)
constraint ctAusserbetriebnahmeEOP[Produktionssysteme]; 
//// (23)
constraint ctAusserbetriebnahmeEOPProduktionssystemePotentiell[ProduktionssystemePotentiell][Betrachtungszeitraum];
//// (24)
constraint ctAusserbetriebnahmeEOPProduktionssystemeBestehend[ProduktionssystemeBestehend][Betrachtungszeitraum];
//// (22)
constraint ctInbetriebnahmeSOPProduktionssystemePotentiell[ProduktionssystemePotentiell][Betrachtungszeitraum];
//// (3) a)
constraint ctInbetriebnahmeProdSOPN[ProduktionssystemePotentiell][Betrachtungszeitraum];
//// (3) b)
constraint ctInbetriebnahmeProdSOP[ProduktionssystemePotentiell][Betrachtungszeitraum];
//// (5)
constraint ctInbetriebnahmeSOPProd[ProduktionssystemePotentiell][Betrachtungszeitraum];
//// 2 a) 
constraint ctStandortBetriebN[Standorte][Betrachtungszeitraum];
//// 2 b) 
constraint ctStandortBetrieb[Standorte][Betrachtungszeitraum];
//// (4)
constraint ctInbetriebnahmeSOP[ProduktionssystemePotentiell]; 
//// (25)
constraint ctWiederinbetriebnahmeProduktionssystemeBestehend[ProduktionssystemeBestehend];
//// (26)
constraint ctWiederinbetriebnahmeProduktionssystemePotentiell[ProduktionssystemePotentiell];
//// (27)
constraint ctKonfigurationVorSOP[ECV][Betrachtungszeitraum];
//// (28)
constraint ctKonfigurationSOP[ECV][Betrachtungszeitraum];
//// (29)
constraint ctKonfigurationSOPProduktionssystemePotentiell[ECN][Betrachtungszeitraum];
//// (34)
// constraint ctKapazitaetsverlustBefaehigung[ECIN][BetrachtungszeitraumErweitert]; 
//// (37) 
// constraint ctKapazitaetsverlustErweiterung[EKIN][BetrachtungszeitraumErweitert]; 
//// (40) 
// constraint ctKapazitaetsverlustVerlagerung[VES][BetrachtungszeitraumErweitert];
//// (48) 
constraint ctEinhaltungKapazitaet[EFSGT];
//// (49)
constraint ctBeschraenkungUeberlastkapazitaet[EFSGT]; 
//// (50) 
// constraint ctKapazitaetsverlusteSumme[Produktionssysteme][Betrachtungszeitraum]; 
//// (51)
// constraint ctKapazitaetsverlusteEinschraenkung[Produktionssysteme][Betrachtungszeitraum]; 
//// (52)
constraint ctKapazitaet[Produktionssysteme][Betrachtungszeitraum];  
//// (53)
constraint ctMaterialzuflussKomponenten[ORIf][ErzeugnisseKomponenten][Betrachtungszeitraum];
//// (54)
constraint ctMaterialabfluss[EP][Betrachtungszeitraum];
//// (55) 
constraint ctBilanzgleichungErzeugnisse[Erzeugnisse][Betrachtungszeitraum];
//// (58) 
// constraint ctEinhaltungLagerkapazitaet [EP][Betrachtungszeitraum];
//// (56)
// constraint ctAnfangsbestandLagerProduktionssystemeBestehend[EP];
//// (57)
constraint ctAnfangsbestandLagerProduktionssystemePotentiell[EP];
//// (59)
constraint ctVermeidungKundenueberbelieferung[Kunden][ErzeugnisseEnderzeugnisse][Betrachtungszeitraum];  
//// (68)
constraint ctMarktbedarf[ErzeugnisseEnderzeugnisse][Betrachtungszeitraum]; 
//// (69)
constraint ctMarktbedarfUnterschreitung[ErzeugnisseEnderzeugnisse][Betrachtungszeitraum]; 
//// (72)
// constraint ctFixkostenfaktor[Produktionssysteme][Betrachtungszeitraum]; 
//// (74) 
// constraint ctSprungintervalleLimit[Produktionssysteme][Betrachtungszeitraum]; 
//// (75)/(76)
// constraint ctSprungintervalleGrenzen[EI][Betrachtungszeitraum];
//// (82)
// constraint ctBilanzgleichungVerzollung[ROUz][Betrachtungszeitraum];
//// (77) b)
// constraint ctVariablerProduktionskostensatz[Produktionssysteme][Betrachtungszeitraum]; 
//// (83)
constraint ctMindestauslastungProduktionssystem[Produktionssysteme][Betrachtungszeitraum];  
//// (84) 
	//* Fokus liegt zunchst auf Belieferung aus der Triade/dem Markt. 
	// constraint ctLocalMinProduktion[ErzeugnisseEnderzeugnisse][Laender][Betrachtungszeitraum]; 
constraint ctMarketMinProduktion[ErzeugnisseEnderzeugnisse][Maerkte][Betrachtungszeitraum];
//// (85)
// constraint ctBudget[Betrachtungszeitraum]; 
//// Bosch (1)
constraint ctVerfuegbareTechnischeKapazitaet[Produktionssysteme][Betrachtungszeitraum];
//*** Um die Mglichkeit einer Verlagerung korrekt abzubilden, bentigt man zwei Entscheidungsvariablen: 
//*** Zustandsvariable bEST, die die Zuordnung zwischen Standort und Produktionssystem im Zeitraum t beschreibt
//*** Modifikationsvariable bVYT, die eine Zustandsnderung, in diesem Fall eine Verlagerung von einem zu einem anderen Standort darstellt. 
//*** Folgende Nebenbedingung stellt sich, dass nur ein Standort zu einem Produktionssystem whrend jedes Zeitraums zugeordnet werden kann. 
constraint ctProduktionssystemStandort[Produktionssysteme][Betrachtungszeitraum];
constraint ctStandortProduktionssystemePotentiell[ProduktionssystemePotentiell]; 


subject to {

	forall(ec in EC,p in Erzeugnisse,t in Betrachtungszeitraum) {
		//// (9) Mglichkeit eines Produktionssystems zur Produktion: Konfiguration Produktionssystem
		//// (9) a) 
		ctProduktionsvolumenKonfigurationNExistent[ec][p][t]: bCYT[ec][t] == 0 || config[<ec.Konfiguration,p>]== 0 => fPV[<ec.Produktionssysteme,p>][t] == 0;
		//// (9) b) 
		ctProduktionsvolumenKonfigurationExistent[ec][p][t]: bCYT[ec][t] == 1 && config[<ec.Konfiguration,p>]==1 => fPV[<ec.Produktionssysteme,p>][t] >= 0;
	}	
	
	forall(ec in EC,t in Betrachtungszeitraum) {	
		//// (10) Synchronisierung Betrieb und Konfiguration
		ctBetriebKonfiguration[ec][t]: bEIT[ec.Produktionssysteme][t] >= bCYT[ec][t];
	}	
	
	//* Lagerhaltungskosten und maximale Lagerkapazitten werden nicht in dieser Form bercksichtigt. Lagerhaltungskosten werden als
	//* Kapitalbindungskosten whrend der Transportzeit modelliert, eine maximale Lagerkapazitt wird nicht bercksichtigt. 
	// forall(ep in EP,t in Betrachtungszeitraum) {	
		//// (58) Einhaltung maximaler Lagerkapazitt
		// ctEinhaltungLagerkapazitaet[ep][t]: fINV[ep][t] <= maxinv[ep][t];
	// }	
	
	
	forall(ec in ECV: ec.Produktionssysteme in ProduktionssystemeBestehend,t in Betrachtungszeitraum: t<cytVSOP[ec]) {
		//// (27) Verfgbarkeit der Konfiguration vor dem SOP der Konfiguration
		ctKonfigurationVorSOP[ec][t]: bCYT[ec][t] == 0; 
	}
	
		forall(ec in ECV: ec.Produktionssysteme in ProduktionssystemeBestehend,t in Betrachtungszeitraum: t==cytVSOP[ec]) {
		//// (28) Verfgbarkeit der Konfiguration zum SOP der Konfiguration
		ctKonfigurationSOP[ec][t]: bCYT[ec][t] == 1; 
	}
	
	forall(ec in ECN: ec.Produktionssysteme in ProduktionssystemePotentiell,t in Betrachtungszeitraum: t<cytNSOP[ec]) {
		 
		//// (29) Bercksichtigung des zeitlichen Vorlaufs von Modifikationsmanahmen Konfiguration
		ctKonfigurationSOPProduktionssystemePotentiell[ec][t]: bCYT[ec][t]==0;
		
	}
	
	forall(ec1c2 in ECIN, t in Betrachtungszeitraum: t > MinPeriode) {
		//// (12) Befhigungssequenz
		ctBefaehigung[ec1c2 ][t]: bCYTIN[ec1c2][t] == bCYT[<ec1c2.Produktionssysteme,ec1c2.Konfiguration>][t]*bCYT[<ec1c2.Produktionssysteme,ec1c2.Vorkonfiguration>][t-1];
	}
		
	
	//* Kapazittsverlust wird nicht durch Anteil an Planungsperiode modelliert, sondern, falls er auftritt ab SOP implizit ber CT und OEE. 
	//* I.d.R wird ein Kapazittsverlust nicht bercksichtigt.
	
	// forall(ec1c2 in ECIN, t in BetrachtungszeitraumErweitert: t > zvec[<ec1c2.Produktionssysteme,ec1c2.Konfiguration>]+1 && t <= MaxPeriode + zvec[<ec1c2.Produktionssysteme,ec1c2.Konfiguration>]+1) {
		//// (34) Kapazittsverlust durch Befhigungen
		// ctKapazitaetsverlustBefaehigung[ec1c2][t]: fLOSSec[ec1c2][t-zvec[<ec1c2.Produktionssysteme,ec1c2.Konfiguration>]-1] == 
		// sum(tg in BetrachtungszeitraumGeneriken: tg <t && t-tg <= MaxPeriode)(bCYTIN[ec1c2][t-tg]*lossec[<ec1c2.Produktionssysteme,ec1c2.Konfiguration>][tg]);
	// }
	
	//* Kapazittsverlust wird nicht durch Anteil an Planungsperiode modelliert, sondern, falls er auftritt, ab SOP implizit ber CT und OEE.
	//* I.d.R wird ein Kapazittsverlust nicht bercksichtigt.
	
	// forall(ek1k2 in EKIN, t in BetrachtungszeitraumErweitert: t > zvek[<ek1k2.Produktionssysteme,ek1k2.Kapazitaetsstufe>]+1 && t <= MaxPeriode + zvek[<ek1k2.Produktionssysteme,ek1k2.Kapazitaetsstufe>]+1) {
		//// (37) Kapazittsverlust durch Erweiterungen
		// ctKapazitaetsverlustErweiterung[ek1k2][t]: fLOSSek[ek1k2][t-zvek[<ek1k2.Produktionssysteme,ek1k2.Kapazitaetsstufe>]-1] == 
		// sum(tg in BetrachtungszeitraumGeneriken: tg <t && t-tg <= MaxPeriode)(bKYTIN[ek1k2][t-tg]*lossek[<ek1k2.Produktionssysteme,ek1k2.Kapazitaetsstufe>][tg]);
	 //}
	
	//* Kapazittsverlust wird nicht durch Anteil an Planungsperiode modelliert, sondern, ab SOP implizit ber CT und OEE.
	// forall(es1s2 in VES, t in BetrachtungszeitraumErweitert: t > zves[<es1s2.Produktionssysteme,es1s2.NachStandort>]+1 && t <= MaxPeriode + zves[<es1s2.Produktionssysteme,es1s2.NachStandort>]+1) {
		//// (40) Kapazittsverlust durch Verlagerung
		// ctKapazitaetsverlustVerlagerung[es1s2][t]: fLOSSes[es1s2][t-zves[<es1s2.Produktionssysteme,es1s2.NachStandort>]-1] == 
		// sum(tg in BetrachtungszeitraumGeneriken: tg <t && t-tg <= MaxPeriode)(bVYT[es1s2][t-tg]*losses[<es1s2.Produktionssysteme,es1s2.NachStandort>][tg]);
	// }
	
	forall(efsgt in EFSGT){
		//// (48) Einhaltung der maximalen Kapazitt
		ctEinhaltungKapazitaet[efsgt]: fAZH[efsgt.Produktionssysteme][efsgt.Periode] - fAUE[efsgt.Produktionssysteme][efsgt.Periode] <= capAZH[efsgt.Produktionssysteme][efsgt.Periode];
	//* Kapazittsverlust wird ber OEE und CT abgebildet, nicht ber einen anteiligen Kapazittsverlust. 
		// (1-fLOSS[efsgt.Produktionssysteme][efsgt.Periode]/tsh[efsgt.Produktionssysteme][efsgt.Periode]);	
		//// (49) Beschrnkung der berlaskapazitt
		ctBeschraenkungUeberlastkapazitaet[efsgt]: fAUE[efsgt.Produktionssysteme][efsgt.Periode] <= maxuek[efsgt.Produktionssysteme][efsgt.Periode]; 
	}
	
	//* Eine Disqualifikation tritt im Betrachtungszeitraum nicht auf, weshalb die Binrvariable eliminiert wird. 
	// forall(ec1c2 in ECDE, t in Betrachtungszeitraum: t > MinPeriode) {
		//// (13) Disqualifikationssequenz
		// ctDisqualifikation[ec1c2][t]: bCYTDE[ec1c2][t] == bCYT[<ec1c2.Produktionssysteme,ec1c2.Konfiguration>][t]*bCYT[<ec1c2.Produktionssysteme,ec1c2.Vorkonfiguration>][t-1];
	//}
	
	forall(e in Produktionssysteme,t in Betrachtungszeitraum) {
		 
		//// (1) Mglichkeit eines Produktionssystems zur Produktion: Betrieb Produktionssystem
		//// (1) a) 
		ctProduktionsvolumenBetriebN[e][t]: bEIT[e][t]== 0 => fPVe[e][t] == 0;
		//// (1) b)
		ctProduktionsvolumenBetrieb[e][t]: bEIT[e][t]== 1 => fPVe[e][t] >= 0;
		//// (1) c) Verknpfung fPVe und fPV
		ctSummeProduktionsvolumenProduktionssystem[e][t]: fPVe[e][t] == sum(ep in EP: ep.Produktionssysteme == e)fPV[ep][t];
		//// (6) Sychronisierung der Auerbetriebnahme mit der Produktion
		ctAusserbetriebnahmeProdEOP[e][t]:bEIT[e][t-1]- bEIT[e][t] <= bEIeop[e][t-1];
		//// (7) Synchronisierung der Produktion mit der Auerbetriebnahme
		ctAusserbetriebnahmeEOPProd[e][t]: bEIT[e][t+1] - bEIeop[e][t] <= 1;
		//// (11) Einzigartigkeit der Konfiguration
		ctKonfiguration[e][t]: sum(ec in EC: ec.Produktionssysteme == e) bCYT[ec][t] == 1; 
		//// (16) Einzigartigkeit der Kapazitaetsstufe
		ctKapazitaetsstufe[e][t]: sum(ek in EK: ek.Produktionssysteme == e) bKYT[ek][t] == 1; 
	//* Kapazitsverluste werden durch OEE und CT Verluste bercksichtigt und nicht separat ausgewiesen. 
		//// (50) Summe der Kapazitaetsverluste
		// ctKapazitaetsverlusteSumme[e][t]: fLOSS[e][t] == sum(ec1c2 in ECIN: ec1c2.Produktionssysteme == e)fLOSSec[ec1c2][t] + sum(ek1k2 in EKIN: ek1k2.Produktionssysteme == e)fLOSSek[ek1k2][t] + sum(es1s2 in VES: es1s2.Produktionssysteme == e)fLOSSes[es1s2][t];
		//// (51) Einschraenkung der Kapazitaetsverluste auf produktiven Zeitanteil
		// ctKapazitaetsverlusteEinschraenkung[e][t]: fLOSS[e][t] <= tsh[e][t]; 
		//// (52) Bestimmung der Kapazitaet
		ctKapazitaet[e][t]: fAZH[e][t] == sum(ekp in EKP: ekp.Produktionssysteme==e)ct[<ekp.Produktionssysteme,ekp.Erzeugnisse>][t]*fPV[<ekp.Produktionssysteme,ekp.Erzeugnisse>][t]*bKYT[<ekp.Produktionssysteme,ekp.Kapazitaetsstufe>][t]*ekp.Kapazitaetsstufe;
	//* Fixkosten, Sprungfixe Kosten werden nicht bercksichtigt. Produktionskosten beziehen sich alleinig auf Cash Flow relevanten, variablen Anteil der Produktherstellkosten
		//// (72) Berechnung des periodenspezifischen Fixkostenfaktors fFIXe[e][t]
		// ctFixkostenfaktor[e][t]: fFIXe[e][t]  == sum(ek in EK: ek.Produktionssysteme==e) (bKYT[ek][t]*cFIXkyt[ek])*bEIT[ek.Produktionssysteme][t];
		//// (74) Begrenzung der Sprungintervalle je Produktionssystem
		// ctSprungintervalleLimit[e][t]: sum (i in Sprungintervalle)bEII[<e,i>][t] == bEIT[e][t];
		//// (77) b) Berechnung des variablen Produktionskostensatzes
	//* Variable Produktionskosten werden nicht durch Kostentreiber Maschinenstunden verursacht, sondern durch die zu produzierenden Volumen auf der Maschine.
		// ctVariablerProduktionskostensatz[e][t]: cVAR[e][t] == cMAR[e][t] + cPAR[e][t];
		//// (83) EinhaltungMindestauslastung
		ctMindestauslastungProduktionssystem[e][t]: fAZH[e][t] >= mincap[e][t]*capAZH[e][t]*bEIT[e][t];
	//*** Da in der Volumenallokation im Anwendungszusammenhang die Technische Kapazitt, d.h. die produzierbare Stckzahl je Produktionssystem
	//*** genutzt wird, um Kapazittsauslastungen zu bestimmen, wird die verfgbare Technische Kapazitt hier gesondert modelliert, um sie in der
	//*** Analyse mit der bentigten technischen Kapazitt zu vergleichen, die sich ber die Summe der Produktionsvolumen einzelner Erzeugnisse
	//*** ermitteln lsst. 
		//// Bosch (1)
		ctVerfuegbareTechnischeKapazitaet[e][t]: fAZV[e][t] == capAZH[e][t]/(sum(ep in EP: ep.Produktionssysteme == e)(ct[ep][t]*fPV[ep][t])/
		sum(ep in EP: ep.Produktionssysteme == e)(fPV[ep][t]));
		//* Um die Mglichkeit einer Verlagerung korrekt abzubilden, bentigt man zwei Entscheidungsvariablen: 
		//* Zustandsvariable bEST, die die Zuordnung zwischen Standort und Produktionssystem im Zeitraum t beschreibt
		//* Modifikationsvariable bVYT, die eine Zustandsnderung, in diesem Fall eine Verlagerung von einem zu einem anderen Standort darstellt. 
		//* Folgende Nebenbedingung stellt sich, dass nur ein Standort zu einem Produktionssystem whrend jedes Zeitraums zugeordnet werden kann. 
			// ctProduktionssystemStandort[e][t]: sum(es in PNS: es.Produktionssysteme == e) bEST[es][t] == 1; 
	}
	
	//* Fixkosten, Sprungfixe Kosten werden nicht bercksichtigt. Produktionskosten beziehen sich alleinig auf Cash Flow relevanten, variablen Anteil der Produktherstellkosten
	// forall(ei in EI, t in Betrachtungszeitraum){
		//// (75)/(76) Einordung Sprungintervalle 
		// ctSprungintervalleGrenzen[ei][t]: UG[ei] <= fPVe[ei.Produktionssysteme][t] <= OG[ei] => bEII[ei][t]==1;
	// }
	
	forall(e2 in DESf,pc in ErzeugnisseKomponenten, t in Betrachtungszeitraum){
		//// (53) Sicherung des Materialzuflusses (Komponentenbedarf)
		ctMaterialzuflussKomponenten[e2][pc][t]: sum(e1s1e2s2pc in ROUf: e1s1e2s2pc.ProduktionssystemeProduktionssystemLieferung==e2 && e1s1e2s2pc.Erzeugnisse==pc) fTVf[e1s1e2s2pc][t] == sum(ep2 in EP: ep2.Produktionssysteme==e2)sum(<ep2.Erzeugnisse,pc> in BOP)mbkp[<ep2.Erzeugnisse,pc>]*fPV[ep2][t];
			
	}
	
	//** Lagerhaltung wird nicht modelliert, weshalb fINV der Gleichung entnommen wird. 
	forall(e1p in EP: e1p.Produktionssysteme in ORI,t in Betrachtungszeitraum){
		//// (54) Sicherung des Materialabflusses 
		ctMaterialabfluss[e1p][t]: fPV[e1p][t]  == sum(<e1p.Produktionssysteme,s1,e2,s2,e1p.Erzeugnisse> in ROUf) fTVf[<e1p.Produktionssysteme,s1,e2,s2,e1p.Erzeugnisse>][t] + 
		sum(<e1p.Produktionssysteme,s1,h,e1p.Erzeugnisse> in ROUh) fTVh[<e1p.Produktionssysteme,s1,h,e1p.Erzeugnisse>][t];
	}
	
	// forall(e1p in EP: e1p.Produktionssysteme in ORI,t in Betrachtungszeitraum){
		//// (54) Sicherung des Materialabflusses 
		// ctMaterialabfluss[e1p][t]: fPV[e1p][t] + fINV[e1p][t-1] == sum(<e1p.Produktionssysteme,s1,e2,s2,e1p.Erzeugnisse,o> in ROUf) fTVf[<e1p.Produktionssysteme,s1,e2,s2,e1p.Erzeugnisse,o>][t] + 
		// sum(<e1p.Produktionssysteme,s1,h,e1p.Erzeugnisse,o> in ROUh) fTVh[<e1p.Produktionssysteme,s1,h,e1p.Erzeugnisse,o>][t] + fINV[e1p][t];
	// }
	
	//** Lagerhaltung wird nicht modelliert, weshalb fINV der Gleichung entnommen wird. 
	forall(p in Erzeugnisse, t in Betrachtungszeitraum){
		//// (55) BilanzgleichungErzeugnisse: Produktionsvolumen + Lagerbestandsvernderungen = Transportvolumina
		ctBilanzgleichungErzeugnisse[p][t]: sum(ep in EP: ep.Produktionssysteme in ORI && ep.Erzeugnisse == p)fPV[ep][t] == 
		sum(e1s1e2s2p in ROUf: e1s1e2s2p.ProduktionssystemeProduktionssystemBelieferung  in ORIf && e1s1e2s2p.Erzeugnisse == p) fTVf[e1s1e2s2p][t] + sum(e1s1hp in ROUh:e1s1hp.ProduktionssystemeKundeBelieferung in ORIh && e1s1hp.ErzeugnisseEnderzeugnis==p) fTVh[e1s1hp][t]; 
	}
	
	//forall(p in Erzeugnisse, t in Betrachtungszeitraum){
		//// (55) BilanzgleichungErzeugnisse: Produktionsvolumen + Lagerbestandsvernderungen = Transportvolumina
		// ctBilanzgleichungErzeugnisse[p][t]: sum(ep in EP: ep.Produktionssysteme in ORI && ep.Erzeugnisse == p)(fPV[ep][t]+ fINV[ep][t-1]-fINV[ep][t]) == 
		// sum(e1s1e2s2po in ROUf: e1s1e2s2po.ProduktionssystemeProduktionssystemBelieferung  in ORIf && e1s1e2s2po.Produkte == p) fTVf[e1s1e2s2po][t] + sum(e1s1hpo in ROUh:e1s1hpo.ProduktionssystemeKundeBelieferung in ORIh && e1s1hpo.ErzeugnisseEnderzeugnis==p) fTVh[e1s1hpo][t]; 
	// }
	
	forall(p in ErzeugnisseEnderzeugnisse,t in Betrachtungszeitraum){ 
		//// (68) Berechnung des unerfllten Marktbedarfs
		ctMarktbedarf[p][t]: fFVpe[p][t] == sum(h in Kunden)dem[h][p][t] - sum(e1s1hp in ROUh: e1s1hp.ErzeugnisseEnderzeugnis==p) fTVh[e1s1hp][t];
		//// (67) Vermeidung der berschreitung der Untererfllung des Marktbedarfs
		//* Es wird eine vollkommene Erfllung des Marktbedarfs als Voraussetzung angenommen.
			// ctMarktbedarfUnterschreitung[p][t]:	fFVpe[p][t] <= maxfv[p][t];
	}	
	
	//* Zollkosten werden in Abhngigkeit der Transporbeziehung und den Transportvolumen auf der jeweiligen Transportbeziehung errechnet. 
	//* Eine gesonderte Betrachtung der Zollkosten ist deshalb berflssig. 
	// forall(<z1,z2,p> in ROUz, t in Betrachtungszeitraum){
		//// (82) Bilanzgleichung Verzolltes Transportvolumen = zu verzollendes Transportvolumen
		// ctBilanzgleichungVerzollung[<z1,z2,p>][t]: fTVz[<z1,z2,p>] [t] == sum(<e,s,z1> in PNSZ, <h,z2> in HZ,<e,s,h,p,o> in ROUh)fTVh[<e,s,h,p,o>][t]+
		// sum(<e1,s1,e2,s2,p,o> in ROUf, <e1,s1,z1> in PNSZ, <e2,s2,z2> in PNSZ ) fTVf[<e1,s1,e2,s2,p,o>][t];
	// }
	
	forall(ek1k2 in EKIN, t in Betrachtungszeitraum: t > MinPeriode) {
		//// (17) Erweiterungssequenz
		ctErweiterung[ek1k2][t]: bKYTIN[ek1k2][t] == bKYT[<ek1k2.Produktionssysteme,ek1k2.Kapazitaetsstufe>][t]*bKYT[<ek1k2.Produktionssysteme,ek1k2.VorKapazitaetsstufe>][t-1];
	}
	
	forall(ek1k2 in EKDE, t in Betrachtungszeitraum: t > MinPeriode) {
		//// (18) Rueckbausequenz
		ctRueckbau[ek1k2][t]: bKYTDE[ek1k2][t] == bKYT[<ek1k2.Produktionssysteme,ek1k2.Kapazitaetsstufe>][t]*bKYT[<ek1k2.Produktionssysteme,ek1k2.Vorkapazitaetsstufe>][t-1];
	}
	
	//* Da keine Verlagerung im Betrachtungszeitraum vorgenommen wird, wird diese Nebenbedingung ausgeblendet
	// forall(es1s2 in VES, t in Betrachtungszeitraum: t > MinPeriode) {
		//// Verlagerungssequenz
		// ctVerlagerung[es1s2][t]: bVYT[es1s2][t] == bEST[<es1s2.Produktionssysteme,es1s2.NachStandort>][t]*bEST[<es1s2.Produktionssysteme,es1s2.VonStandort>][t-1];
	// }

	forall(s in Standorte,t in Betrachtungszeitraum) {	
		//// (2) Mglichkeit eines Produktionssystems zur Produktion: Betrieb Standort
		//// (2) a) 
		ctStandortBetriebN[s][t]:  eit[<s,t>]== 0 => sum(es in PNS: es.Standorte == s) bEIT[es.Produktionssysteme][t] == 0;
		//// (2) b) 
		ctStandortBetrieb[s][t]: eit[<s,t>]== 1 => sum(es in PNS: es.Standorte == s) bEIT[es.Produktionssysteme][t] >= 0;
	}
	
	forall(e in ProduktionssystemeBestehend){
		 
		//// (21) Betrieb bestehender Produktionssysteme
		ctBetriebProduktionsssystemeBestehend[e]: bEIT[e][MinPeriode]==1;
		
	}
	
	forall(e in ProduktionssystemePotentiell,t in Betrachtungszeitraum: t<eSOP[e]) {
		 
		//// (22) Bercksichtigung des zeitlichen Vorlaufs von Modifikationsmanahmen
		ctInbetriebnahmeSOPProduktionssystemePotentiell[e][t]: bEIT[e][t]==0;
		
	}
	
		forall(e in ProduktionssystemePotentiell,t in Betrachtungszeitraum: t>enEOP[e]) {
		 
		//// (23) Bercksichtigung des Betriebszustandes von potentiellen Produktionssystemen
		ctAusserbetriebnahmeEOPProduktionssystemePotentiell[e][t]: bEIT[e][t]==0;
	}
	
	forall(e in ProduktionssystemeBestehend,t in Betrachtungszeitraum: t>evEOP[e]) {
		 
		//// (24) Bercksichtigung des Betriebszustandes von bestehenden Produktionssystemen
		ctAusserbetriebnahmeEOPProduktionssystemeBestehend[e][t]: bEIT[e][t]==0;
	}
	
	forall(e in ProduktionssystemeBestehend,t in Betrachtungszeitraum: t>MinPeriode) {
		 
		//// (25) Keine Wiederinbetriebnahme von stillgelegten, bestehenden Produktionssystemen
		ctWiederinbetriebnahmeProduktionssystemeBestehend[e]: bEIT[e][t]<=bEIT[e][t-1];
	}
	
	
	forall(e in ProduktionssystemePotentiell,tt in Betrachtungszeitraum) {
		 
		//// (3) Synchronisierung der Produktion mit der Inbetriebnahme
		//// (3) a)
		ctInbetriebnahmeProdSOPN[e][tt]: sum(t in Betrachtungszeitraum: t<=tt)bEIsop[e][t] == 0 => sum(t in Betrachtungszeitraum: t<=tt)bEIT[e][t]==0;
		//// (3) b) 
		ctInbetriebnahmeProdSOP[e][tt]: sum(t in Betrachtungszeitraum: t<=tt)bEIsop[e][t] == 1 => sum(t in Betrachtungszeitraum: t<=tt)bEIT[e][t]>=0;
	}
	
	forall(e in ProduktionssystemePotentiell) {
		 
		//// (14) Konfiguration potentieller Produktionssysteme
		ctKonfigurationProduktionssystemePotentiell[e]: sum(ec in ECN: ec.Produktionssysteme==e)bCYT[ec][MinPeriode] == 1; 
		//// (19) Kapazitaetsstufe potentieller Produktionssysteme
		ctKapazitaetsstufeProduktionssystemePotentiell[e]: sum(ek in EK: ek.Produktionssysteme==e)bKYT[ek][MinPeriode] == 1; 
		//* Initiale Zuordnung potentieller Produktionssysteme zu einem  Standort. Wird aufgrund von nicht bercksichtigter Netzwerkmodifikation Verlagerung
		//* ausgeblendet. 
		// ctStandortProduktionssystemePotentiell[e]: sum(es in PNS: es.Produktionssysteme==e)bEST[es][MinPeriode] == 1; 
		//// (4) Einmaligkeit der Inbetriebnahme
		ctInbetriebnahmeSOP[e]: sum(t in Betrachtungszeitraum)bEIsop[e][t]<= 1;
		//// (26) Keine Wiederinbetriebnahme von stillgelegten, bestehenden Produktionssystemen
		ctWiederinbetriebnahmeProduktionssystemePotentiell[e]: sum(t in Betrachtungszeitraum: t < MaxPeriode)abs(bEIT[e][t+1]- bEIT[e][t])<=2; 
		
	}
	
	forall(e in ProduktionssystemePotentiell,t in Betrachtungszeitraum) {
		 
		//// (5) Synchronisierung der Inbetriebnahme mit der Produktion 
		ctInbetriebnahmeSOPProd[e][t]: bEIsop[e][t] <= bEIT[e][t];
	}

	forall (e in Produktionssysteme){
		//// (8) Einmaligkeit der Auerbetriebnahme
		ctAusserbetriebnahmeEOP[e]: sum(t in Betrachtungszeitraum)bEIeop[e][t]<= 1;	
	}
	//* Lagerhaltungskosten und maximale Lagerkapazitten werden nicht in dieser Form bercksichtigt. Lagerhaltungskosten werden als
	//* Kapitalbindungskosten whrend der Transportzeit modelliert, eine maximale Lagerkapazitt wird nicht bercksichtigt.
	// forall (ep in EP: ep.Produktionssysteme in ProduktionssystemeBestehend){
		//// (56) Anfangsbestand bei bestehenden Produktionssystemen
		// ctAnfangsbestandLagerProduktionssystemeBestehend[ep]: fINV[ep][MinPeriode] == invMinPeriode[ep];
	// }
	
	//* Lagerhaltungskosten und maximale Lagerkapazitten werden nicht in dieser Form bercksichtigt. Lagerhaltungskosten werden als
	//* Kapitalbindungskosten whrend der Transportzeit modelliert, eine maximale Lagerkapazitt wird nicht bercksichtigt.
	// forall (ep in EP: ep.Produktionssysteme in ProduktionssystemePotentiell){
		//// (57) Kein Anfangsbestand bei potentiellen Produktionssystemen
		// ctAnfangsbestandLagerProduktionssystemePotentiell[ep]: fINV[ep][MinPeriode] == 0;
	// }
	
	forall(h in Kunden,p in ErzeugnisseEnderzeugnisse,t in Betrachtungszeitraum) {
		//// (59) Vermeidung einer Kundenberbelieferung
		ctVermeidungKundenueberbelieferung[h][p][t]: sum(<e1,s1,h,p> in ROUh) fTVh[<e1,s1,h,p>][t] <= dem[h][p][t];
	}
	
	// forall(p in ErzeugnisseEnderzeugnisse, l in Laender, t in Betrachtungszeitraum) {
		//// (84) Einhaltung der lokalen Mindestproduktion
		//* Fokus liegt zunchst auf Belieferung aus der Triade/dem Markt. 
		// ctLocalMinProduktion[p][l][t]: sum(esl in PNSL: esl.Laender == l)fPV[<esl.Produktionssysteme,p>][t] >= minvalloc[l][t]*sum(hl in HL: hl.Laender ==l)dem[hl.Kunden][p][t];	
	// }
	
	forall(p in ErzeugnisseEnderzeugnisse, m in Maerkte, t in Betrachtungszeitraum) {
		//// (84) Einhaltung der lokalen Mindestproduktion
		ctMarketMinProduktion[p][m][t]: sum(eslm in PNSLM: eslm.Maerkte == m)fPV[<eslm.Produktionssysteme,p>][t] >= minvalmarket[m][t]*sum(hlm in HLM: hlm.Maerkte == m)dem[hlm.Kunden][p][t];	
	}
	
	//* Wenn es zu einer separaten Kapazittsallokation kommt, die als Engangsparameter fr die modellgesttzte Volumenallokation fungiert und 
	//* in der bereits Budgetbeschrnkungen bercksichtigt werden, mssen diese nicht nochmals in der modellgesttzten Volumenallokation
	//* abgefragt werden.
	// forall(t in Betrachtungszeitraum){
		//// (85) Einhaltung des Budgets 
		// ctBudget[t]: EAW[t]<=maxcapex[t];	
	// }
}

/**********************************************************/
/**********************************************************/
//Ergebnisse in Datenbank_Ergebnisse schreiben	  

//Sager Result Sets

// binre Entscheidungsvariablen in Datenbank_Ergebnisse schreiben

tuple resultbEIT {
	string Produktionssysteme;
	int Betrachtungszeitraum;
	float bEIT;
}

{resultbEIT} ResultbEIT = 
  { <e, t, bEIT [e][t]> | e in Produktionssysteme, t in Betrachtungszeitraum };
  
  tuple resultbEIsop {
	string Produktionssysteme;
	int Betrachtungszeitraum;
	float bEIsop;
}

{resultbEIsop} ResultbEIsop = 
  { <en, t, bEIsop [en][t]> | en in ProduktionssystemePotentiell, t in Betrachtungszeitraum };
  
tuple resultbEIeop {
	string Produktionssysteme;
	int Betrachtungszeitraum;
	float bEIeop;
}

{resultbEIeop} ResultbEIeop = 
  { <e, t, bEIeop[e][t]> | e in Produktionssysteme, t in Betrachtungszeitraum };

tuple resultbCYT {
 	string Produktionssysteme; 
  	string Konfiguration;
	int Betrachtungszeitraum;
	float bCYT;
}
{resultbCYT} ResultbCYT = 
  { < e, c, t, bCYT[<e,c>][t]> | <e,c> in EC, t in Betrachtungszeitraum };
  
  
tuple resultbCYTIN {
 	string Produktionssysteme; 
  	string VorKonfiguration;
  	string Konfiguration;
	int Betrachtungszeitraum;
	float bCYTIN;
}
{resultbCYTIN} ResultbCYTIN = 
  { < e, c1, c2, t, bCYTIN[<e,c1,c2>][t]> | <e,c1,c2> in ECIN, t in Betrachtungszeitraum };

//* Eine Disqualifikation tritt im Betrachtungszeitraum nicht auf, weshalb die Binrvariable eliminiert wird. 	
	// tuple resultbCYTDE {
	 	// string Produktionssysteme; 
	  	// string VorKonfiguration;
	  	// string Konfiguration;
		// int Betrachtungszeitraum;
		// float bCYTDE;
	// }
	// {resultbCYTDE} ResultbCYTDE = 
	 //  { <  e, c1, c2, t, bCYTDE[<e,c1,c2>][t]> | <e,c1,c2> in ECDE, t in Betrachtungszeitraum  };

tuple resultProduktionssystemeErzeugnisse{
	string Produktionssysteme;
	string Erzeugnisse;
	float ct; 
	int fPV;
	int Betrachtungszeitraum; 
}

{resultProduktionssystemeErzeugnisse} ResultProduktionssystemeErzeugnisse = 
 {<e,p,ct[<e,p>][t],fPV[<e,p>][t],t> | e in Produktionssysteme, <e,p> in EP: e in Produktionssysteme, t in Betrachtungszeitraum};


tuple resultbKYT {
 	string Produktionssysteme; 
  	float Kapazitaetsstufe;
	int Betrachtungszeitraum;
	float bKYT;
}
{resultbKYT} ResultbKYT = 
  { < e, k, t, bKYT[<e,k>][t]> | <e,k> in EK, t in Betrachtungszeitraum };
  
  
tuple resultbKYTIN {
 	string Produktionssysteme; 
  	float VorKapazitaetsstufe;
  	float Kapazitaetsstufe;
	int Betrachtungszeitraum;
	float bKYTIN;
}
{resultbKYTIN} ResultbKYTIN = 
  { < e, k1, k2, t, bKYTIN[<e,k1,k2>][t]> | <e,k1,k2> in EKIN, t in Betrachtungszeitraum };


tuple resultbKYTDE {
 string Produktionssysteme; 
  	float VorKapazitaetsstufe;
  	float Kapazitaetsstufe;
	int Betrachtungszeitraum;
	float bKYTDE;
}
{resultbKYTDE} ResultbKYTDE = 
  { <  e, k1, k2, t, bKYTDE[<e,k1,k2>][t]> | <e,k1,k2> in EKDE, t in Betrachtungszeitraum  };

//* Eine Verlagerung tritt im Betrachtungszeitraum nicht auf, weshalb die Entscheidungsvariable eliminiert wird. 

	// tuple resultbEST {
	 	// string Produktionssysteme; 
	  	// string Standorte;
		// int Betrachtungszeitraum;
		// float bEST;
	// }
	// {resultbEST} ResultbEST = 
	 //  { < e, s, t, bEST[<e,s>][t]> | <e,s> in PNS, t in Betrachtungszeitraum };
	  
	  
	// tuple resultbVYT {
	 	// string Produktionssysteme; 
	  	// float VonStandort;
	  	// float NachStandort;
		// int Betrachtungszeitraum;
		// float bVYT;
	// }
	// {resultbVYT} ResultbVYT = 
	  // { < e, s1, s2, t, bVYT[<e,s1,s2>][t]> | <e,s1,s2> in VES, t in Betrachtungszeitraum };


// kontinuierliche Entscheidungsvariablen in Datenbank_Ergebnisse schreiben

//// Ressourcen der Produktion

tuple resultEAuslastung {
	string Produktionssysteme;
	float oee;
	int Betrachtungszeitraum;
	int fAZH;
	int fAUE;
	float capAZH;
	int fPVe;
	int fAZV;
}

{resultEAuslastung} ResultEAuslastung = 
  { <e, oee[e][t], t, fAZH[e][t],fAUE[e][t], capAZH[e][t], fPVe[e][t], fAZV[e][t] > | e in Produktionssysteme, t in Betrachtungszeitraum};



//// Prozesse der Produktion

///// Produktion

tuple resultfPV {
	string Produktionssysteme;
	string Erzeugnisse;
	int Betrachtungszeitraum;
	float fPVe;
}

{resultfPV} ResultfPV = 
  { <e, p, t, fPVe[e][t]> | <e,p> in EP, t in Betrachtungszeitraum};

tuple resultfFVpe {
	string ErzeugnisseEnderzeugnisse;
	int Betrachtungszeitraum;
	float fFVpe;
	
}

{resultfFVpe} ResultfPVpe = 
  { <p, t, fFVpe [p][t]> | p in ErzeugnisseEnderzeugnisse, t in Betrachtungszeitraum};

tuple resultfTVf {
	string ProduktionssystemeProduktionssystemBelieferung;
	string PPBStandort;
	string ProduktionssystemeProduktionssystemLieferung;
	string PPLStandort;
	string Erzeugnisse;
	int Betrachtungszeitraum;
	float fTVf;
}


{resultfTVf} ResultfTVf = 
  { <e1,s1, e2, s2, p, t, fTVf [<e1,s1,e2,s2,p>][t]> | <e1,s1,e2,s2,p> in ROUf, t in Betrachtungszeitraum};
  

tuple resultTVh {
	string ProduktionssystemeKundeBelieferung;
	string PKBStandort;
	string Kunde; 
	string ErzeugnisseEnderzeugnisse;
	int Betrachtungszeitraum;
	float fTVh;
}	

{resultTVh} ResultfTVh = 
  { <e, s, h,p, t, fTVh [<e,s,h,p>][t]> | <e,s,h,p> in ROUh, t in Betrachtungszeitraum };






	
// Entscheidungsausdrcke in Datenbank_Ergebnisse schreiben

tuple resultGKSUM{
	float Gesamtkosten;
}

{resultGKSUM} ResultGKSUM =
{<Gesamtkosten>};

tuple resultGK{
	float Gesamtkosten;
	int Betrachtungszeitraum;
}

{resultGK} ResultGK =
{<GK[t],t> | t in Betrachtungszeitraum};


tuple resultLAWSUM {
	float VariableKosten;
	float LogistikkostenZwischenbelieferungen;
	float LogistikkostenKundenbelieferungen;
	float Logistikkosten;
	float LaufendeAufwendungen;
}	

{resultLAWSUM} ResultLAWSUM = 
  { <VariableKosten,LogistikkostenZwischenbelieferungen,LogistikkostenKundenbelieferungen,Logistikkosten, LaufendeAufwendungen>};

tuple resultLAW{
	float VKE;
	float LOGf;
	float LOGh;
	float LOG;
	float LAW;
	int Betrachtungszeitraum;
}	

{resultLAW} ResultLAW = 
  { <VKE[t],LOGf[t], LOGh[t], LOG[t], LAW[t], t> | t in Betrachtungszeitraum};

tuple resultEAWSUM {
	float EinmalaufwandErrichtung;
	float EinmalaufwandBefaehigung;
	float EinmalaufwandErweiterung;
	float DemontagekostenStilllegung;
	float DemontagekostenReduktion;
}	

{resultEAWSUM} ResultEAWSUM = 
  { <EinmalaufwandErrichtung,EinmalaufwandBefaehigung, EinmalaufwandErweiterung, DemontagekostenStilllegung,DemontagekostenReduktion>};

tuple resultEAW {
	float EAE;
	float EAC;
	float EAK;
	float DAE;
	float DAK;
	int Betrachtungszeitraum;
}	

{resultEAW} ResultEAW = 
  { <EAE[t],EAC[t], EAK[t], DAE[t],DAK[t],t>| t in Betrachtungszeitraum};


